Index: boost/statechart/detail/rtti_policy.hpp
===================================================================
RCS file: /cvsroot/boost/boost/boost/statechart/detail/rtti_policy.hpp,v
retrieving revision 1.13.2.2
diff -u -r1.13.2.2 rtti_policy.hpp
--- boost/statechart/detail/rtti_policy.hpp	3 Dec 2006 15:10:18 -0000	1.13.2.2
+++ boost/statechart/detail/rtti_policy.hpp	31 Mar 2007 10:53:18 -0000
@@ -86,7 +86,7 @@
   typedef bool id_provider_type; // dummy
   #else
   typedef const void * id_type;
-  typedef const id_provider & id_provider_type;
+  typedef const id_provider * id_provider_type;
   #endif
 
   ////////////////////////////////////////////////////////////////////////////
@@ -102,7 +102,7 @@
         #ifdef BOOST_STATECHART_USE_NATIVE_RTTI
         return id_type( typeid( *this ) );
         #else
-        return &idProvider_;
+        return idProvider_;
         #endif
       }
 
@@ -111,9 +111,9 @@
       const CustomId * custom_dynamic_type_ptr() const
       {
         BOOST_ASSERT(
-          ( idProvider_.pCustomId_ == 0 ) ||
-          ( *idProvider_.pCustomIdType_ == typeid( CustomId ) ) );
-        return static_cast< const CustomId * >( idProvider_.pCustomId_ );
+          ( idProvider_->pCustomId_ == 0 ) ||
+          ( *idProvider_->pCustomIdType_ == typeid( CustomId ) ) );
+        return static_cast< const CustomId * >( idProvider_->pCustomId_ );
       }
       #endif
 
@@ -201,7 +201,7 @@
       #ifdef BOOST_STATECHART_USE_NATIVE_RTTI
       rtti_derived_type() : Base( false ) {}
       #else
-      rtti_derived_type() : Base( id_holder< MostDerived >::idProvider_ ) {}
+      rtti_derived_type() : Base( &id_holder< MostDerived >::idProvider_ ) {}
       #endif
   };
 };
